package _VisualDVM.TestingSystem.DVM.DVMSettings.UI;
import Common.Utils.Utils_;
import Common.Visual.Windows.Dialog.DBObjectDialog;
import _VisualDVM.Global;
import _VisualDVM.TestingSystem.DVM.DVMSettings.DVMSettings;
public class DVMSettingsDialog extends DBObjectDialog<DVMSettings, DVMSettingsFields> {
    public DVMSettingsDialog() {
        super(DVMSettingsFields.class);
    }
    @Override
    public int getDefaultHeight() {
        return 500;
    }
    @Override
    public int getDefaultWidth() {
        return 800;
    }
    @Override
    public void validateFields() {
        int min = (int) fields.sMinDimProc.getValue();
        int max = (int) fields.sMaxDimProc.getValue();
        if (max < min)
            Log.Writeln_("Некорректный диапазон размерностей: максимум меньше минимума");
        if ((min == 0) && (max != 0) || (min != 0) && (max == 0))
            Log.Writeln_("Некорректный диапазон размерностей. " +
                    "'0' допускается только одновременно на обеих границах,\n" +
                    "и подразумевает единственный запуск без решётки");
    }
    @Override
    public void fillFields() {
        fields.tfName.setText(Result.description);
        //------->>>
        fields.sMinDimProc.setValue(Result.min_dim_proc_count);
        fields.sMaxDimProc.setValue(Result.max_dim_proc_count);
        fields.cbCube.setSelected(Result.cube == 1);
        //-
        fields.sMaxProc.setValue(Result.max_proc_count);
        fields.cbDvmStat.setSelected(Result.Is_DVM_STAT != 0);
        //---
        fields.fillOptionsLines(Global.testingServer.db.convertOptionsToJson(Result));
        fields.fillEnvironmentsLines(Global.testingServer.db.convertEnvironmentsToJson(Result));
    }
    @Override
    public void ProcessResult() {
        Result.description = fields.tfName.getText();
        Result.min_dim_proc_count = (int) fields.sMinDimProc.getValue();
        Result.max_dim_proc_count = (int) fields.sMaxDimProc.getValue();
        Result.cube = fields.cbCube.isSelected() ? 1 : 0;
        Result.max_proc_count = (int) fields.sMaxProc.getValue();
        Result.Is_DVM_STAT = fields.cbDvmStat.isSelected() ? 1 : 0;
        //--
        Result.packedCompilationOptionsJson = Utils_.gson.toJson(fields.optionsLines.toJson());
        Result.packedRunEnvironmentValuesJson = Utils_.gson.toJson(fields.environmentsLines.toJson());
    }
    @Override
    public void SetReadonly() {
        fields.tfName.setEnabled(false);
        fields.sMinDimProc.setEnabled(false);
        fields.sMaxDimProc.setEnabled(false);
        fields.cbCube.setEnabled(false);
        fields.sMaxProc.setEnabled(false);
        fields.bAddFlags.setEnabled(false);
        fields.bAddEnvironments.setEnabled(false);
        fields.bDeleteEnvironment.setEnabled(false);
        fields.bDeleteFlags.setEnabled(false);
        fields.cbDvmStat.setEnabled(false);
    }
}
